import { Disposable } from '../../disposable';
import { Observable } from 'rxjs/Observable';
import { PrerenderOptions } from './options';
import { Route } from '../../route';
import { Snapshot } from '../../snapshot';
export interface Application<V> extends Disposable {
    renderUri(uri: string, variant?: V): Promise<Snapshot<V>>;
    prerender(options?: PrerenderOptions): Observable<Snapshot<V>>;
    discoverRoutes(): Promise<Array<Route>>;
}
