import { SourceFile } from 'typescript';
import { Disposable } from '../../../disposable';
import { PathReference } from '../../../filesystem';
import { ModuleDeclaration } from '../../project';
export declare class Build implements Disposable {
    readonly basePath: PathReference;
    readonly outputPaths: Array<PathReference>;
    readonly roots: Array<PathReference>;
    private readonly map;
    constructor(basePath: PathReference, outputPaths: Array<PathReference>, roots: Array<PathReference>);
    emit(filename: string, sourceFiles: Array<SourceFile>): void;
    resolveCandidates(source: string): string | null;
    resolve(module: ModuleDeclaration): [string | null, string | null];
    dispose(): void;
    private sourceArray(filename);
}
