Object.defineProperty(exports, "__esModule", { value: true });
var typescript_1 = require("typescript");
var predicates_1 = require("../predicates");
var find_1 = require("../find");
var traverse_1 = require("../traverse");
exports.collectModules = function (basePath, program) {
    var modules = new Array();
    var _loop_1 = function (sourceFile) {
        if (predicates_1.isExternalModule(sourceFile)) {
            return "continue";
        }
        traverse_1.traverse(sourceFile, typescript_1.SyntaxKind.ClassDeclaration, function (node) {
            for (var _i = 0, _a = node.decorators || []; _i < _a.length; _i++) {
                var decorator = _a[_i];
                if (decorator.expression.kind !== typescript_1.SyntaxKind.CallExpression) {
                    continue;
                }
                var subexpr = decorator.expression.expression;
                var imported = find_1.importClause(basePath.toString(), sourceFile, subexpr.text);
                if (imported == null) {
                    continue;
                }
                if (imported.symbol === 'NgModule') {
                    modules.push({
                        source: sourceFile.fileName.replace(/\.(ts|js)$/i, String()),
                        symbol: node.name.text,
                    });
                }
            }
            return false;
        });
    };
    for (var _i = 0, _a = program.getSourceFiles(); _i < _a.length; _i++) {
        var sourceFile = _a[_i];
        _loop_1(sourceFile);
    }
    return modules;
};
//# sourceMappingURL=collect.js.map