export declare class Exception extends Error {
    innerException: Error;
    constructor(msg: string, innerException?: Error);
}
export declare class AggregateException extends Exception {
    exceptions: Array<Exception | Error>;
    constructor(exceptions: Array<Exception | Error>);
    readonly stack: string;
    toString(): string;
}
export declare class NotImplementedException extends Exception {
    constructor();
}
export declare class NotSupportedException extends Exception {
    constructor();
}
export declare class CompilerException extends Exception {
}
export declare class ConfigurationException extends Exception {
}
export declare class FilesystemException extends Exception {
}
export declare class ModuleException extends Exception {
}
export declare class OutputException extends Exception {
}
export declare class PlatformException extends Exception {
}
export declare class RendererException extends Exception {
}
export declare class ResourceException extends Exception {
}
export declare class RuntimeException extends Exception {
}
export declare class RouteException extends Exception {
}
export declare class SnapshotException extends Exception {
}
export declare class StaticAnalysisException extends Exception {
}
export declare class TranspileException extends Exception {
}
