Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = require("path");
var type_1 = require("../type");
var factories_1 = require("../factories");
var static_1 = require("../../static");
describe('Filesystem', function () {
    it('can create a file with text content', function () {
        var path = factories_1.pathFromRandomId();
        path.mkdir();
        try {
            var file = factories_1.fileFromString(path_1.join(path.toString(), static_1.randomId()));
            file.create('Hello World');
            try {
                expect(file.content()).toBe('Hello World');
            }
            finally {
                file.unlink();
            }
        }
        finally {
            path.unlink();
        }
    });
    it('can determine whether a file exists', function () {
        var file = factories_1.fileFromString(__filename);
        expect(file.exists()).toBe(true);
    });
    it('can determine the type of a file or path', function () {
        var path = factories_1.pathFromString(__dirname);
        var file = factories_1.fileFromString(__filename);
        expect(path.type()).toEqual(type_1.FileType.Directory);
        expect(file.type()).toEqual(type_1.FileType.File);
    });
});
//# sourceMappingURL=filesystem.js.map