Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = require("fs");
var FileType;
(function (FileType) {
    FileType[FileType["Unknown"] = 0] = "Unknown";
    FileType[FileType["Directory"] = 1] = "Directory";
    FileType[FileType["File"] = 2] = "File";
    FileType[FileType["Socket"] = 3] = "Socket";
})(FileType = exports.FileType || (exports.FileType = {}));
exports.typeFromPath = function (path) {
    try {
        var stats = fs_1.statSync(path);
        if (stats.isDirectory()) {
            return FileType.Directory;
        }
        else if (stats.isFile()) {
            return FileType.File;
        }
        else if (stats.isSocket()) {
            return FileType.Socket;
        }
    }
    catch (exception) { }
    return FileType.Unknown;
};
//# sourceMappingURL=type.js.map