Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = require("path");
var filesystem_1 = require("../filesystem");
var exception_1 = require("../exception");
exports.inlineStylesheets = function (path, document) {
    try {
        var links = Array.from(document.querySelectorAll('link[rel="stylesheet"]'));
        for (var _i = 0, links_1 = links; _i < links_1.length; _i++) {
            var link = links_1[_i];
            var resource = readResource(window.document, path, link);
            if (resource == null) {
                continue;
            }
            link.parentElement.replaceChild(resource, link);
        }
        return window.document.documentElement.outerHTML;
    }
    catch (exception) {
        throw new exception_1.RuntimeException('Failed to inline stylesheet resources', exception);
    }
};
var readResource = function (document, path, link) {
    if (link.href == null || link.href.length === 0) {
        return null;
    }
    var href = Array.from(link.attributes).find(function (a) { return a.localName.toLowerCase() === 'href'; });
    if (href == null) {
        return null;
    }
    var file = filesystem_1.fileFromString(path_1.join(path.toString(), href.value));
    if (file.exists() === false) {
        return null;
    }
    var element = document.createElement('style');
    element.setAttribute('type', 'text/css');
    element.setAttribute('media', link.media);
    element.textContent = file.content();
    return element;
};
//# sourceMappingURL=stylesheets.js.map