Object.defineProperty(exports, "__esModule", { value: true });
var getVectorDefinitions = function (document) {
    var map = new Map();
    for (var _i = 0, _a = Array.from(document.querySelectorAll("svg > defs > *[id!='']")); _i < _a.length; _i++) {
        var definition = _a[_i];
        var identifier = definition.getAttribute('id');
        if (identifier) {
            map.set(identifier, definition);
        }
    }
    return map;
};
exports.inlineVectorGraphics = function (document) {
    var definitions = getVectorDefinitions(document);
    var links = Array.from(document.querySelectorAll('svg > use'));
    for (var _i = 0, links_1 = links; _i < links_1.length; _i++) {
        var link = links_1[_i];
        var identifier = link.getAttribute('xlink:href');
        var matchingDefinition = definitions.get(identifier.split(/[#\/]/g).pop());
        if (matchingDefinition == null) {
            throw new Error("Cannot find matching SVG definition for " + identifier);
        }
        link.parentElement.replaceChild(matchingDefinition.cloneNode(true), link);
    }
};
//# sourceMappingURL=svg.js.map