Object.defineProperty(exports, "__esModule", { value: true });
var static_1 = require("../static");
var create_1 = require("../runtime/browser-emulation/create");
var stylesheets_1 = require("./stylesheets");
var svg_1 = require("./svg");
exports.transformInplace = function (path, snapshot, options) {
    if (options.inlineStylesheets || options.inlineVectorGraphics) {
        var uri = static_1.ApplicationFallbackOptions.fallbackUri;
        var window_1 = create_1.createModernWindow(snapshot.renderedDocument, uri);
        try {
            if (options.inlineStylesheets) {
                stylesheets_1.inlineStylesheets(path, window_1.document);
            }
            if (options.inlineVectorGraphics) {
                svg_1.inlineVectorGraphics(window_1.document);
            }
            snapshot.renderedDocument = document.documentElement.outerHTML;
        }
        finally {
            window_1.close();
        }
    }
    if (/^<\!DOCTYPE html>/i.test(snapshot.renderedDocument) === false) {
        snapshot.renderedDocument = "<!DOCTYPE html>" + snapshot.renderedDocument;
    }
};
//# sourceMappingURL=transform.js.map