Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var compiler_1 = require("@angular/compiler");
var collectors_1 = require("./collectors");
var resource_loader_1 = require("./resource-loader");
var platform_1 = require("./platform");
var static_1 = require("../static");
var baseProviders = collectors_1.PLATFORM_COLLECTOR_PROVIDERS.concat([
    { provide: core_1.APP_ID, useFactory: static_1.randomizedApplicationId },
    { provide: core_1.PlatformRef, useClass: platform_1.ServerPlatform },
]);
exports.createStaticPlatform = core_1.createPlatformFactory(core_1.platformCore, 'node/static', baseProviders);
var jitProviders = [
    compiler_1.COMPILER_PROVIDERS,
    {
        provide: core_1.COMPILER_OPTIONS,
        useValue: { providers: resource_loader_1.PLATFORM_RESOURCE_LOADER_PROVIDERS.slice() },
        multi: true,
    }
].concat(baseProviders);
exports.createJitPlatform = core_1.createPlatformFactory(compiler_1.platformCoreDynamic, 'node/jit', jitProviders);
//# sourceMappingURL=factory.js.map