var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var url = require("url");
var document_1 = require("../document");
var exception_1 = require("../../exception");
var LocationImpl = (function () {
    function LocationImpl(requestUri, documentContainer) {
        var _this = this;
        this.requestUri = requestUri;
        this.documentContainer = documentContainer;
        this.destruction = new Array();
        this.documentContainer.document.location.assign(requestUri);
        this.initializationPromise = new Promise(function (resolve) { return _this.initialized = function () { return resolve(); }; });
    }
    LocationImpl.prototype.initializationComplete = function () {
        this.initialized();
    };
    LocationImpl.prototype.assign = function (uri) {
        throw new exception_1.NotSupportedException();
    };
    LocationImpl.prototype.replace = function (uri) {
        throw new exception_1.NotSupportedException();
    };
    LocationImpl.prototype.reload = function () {
        throw new exception_1.NotSupportedException();
    };
    Object.defineProperty(LocationImpl.prototype, "href", {
        get: function () {
            return this.requestUri;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LocationImpl.prototype, "host", {
        get: function () {
            return this.parsed(function (u) { return u.host; });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LocationImpl.prototype, "hostname", {
        get: function () {
            return this.parsed(function (u) { return u.hostname; });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LocationImpl.prototype, "origin", {
        get: function () {
            return this.requestUri;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LocationImpl.prototype, "port", {
        get: function () {
            return this.parsed(function (u) { return u.port; });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LocationImpl.prototype, "protocol", {
        get: function () {
            return this.parsed(function (u) { return u.protocol; });
        },
        enumerable: true,
        configurable: true
    });
    LocationImpl.prototype.getBaseHrefFromDOM = function () {
        var element = this.documentContainer.document.querySelector('base');
        if (element == null) {
            return null;
        }
        return element.getAttribute('href') || '/';
    };
    LocationImpl.prototype.onPopState = function (fn) {
        var _this = this;
        this.documentContainer.window.addEventListener('popstate', fn, false);
        this.destruction.push(function () { return _this.documentContainer.window.removeEventListener('popstate', fn); });
    };
    LocationImpl.prototype.onHashChange = function (fn) {
        var _this = this;
        this.documentContainer.window.addEventListener('hashchange', fn, false);
        this.destruction.push(function () { return _this.documentContainer.window.removeEventListener('hashchange', fn); });
    };
    Object.defineProperty(LocationImpl.prototype, "pathname", {
        get: function () {
            return this.documentContainer.window.location.pathname;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LocationImpl.prototype, "search", {
        get: function () {
            return this.documentContainer.window.location.search;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LocationImpl.prototype, "hash", {
        get: function () {
            return this.documentContainer.window.location.hash;
        },
        enumerable: true,
        configurable: true
    });
    LocationImpl.prototype.replaceState = function (state, title, url) {
        this.documentContainer.window.location.hash = url;
    };
    LocationImpl.prototype.pushState = function (state, title, url) {
        this.documentContainer.window.location.hash = url;
    };
    LocationImpl.prototype.forward = function () {
        this.documentContainer.window.history.forward();
    };
    LocationImpl.prototype.back = function () {
        this.documentContainer.window.history.back();
    };
    LocationImpl.prototype.ngOnDestroy = function () {
        this.destruction.forEach(function (d) { return d(); });
    };
    LocationImpl.prototype.parsed = function (fn) {
        try {
            return fn(url.parse(this.href));
        }
        catch (exception) {
            return null;
        }
    };
    return LocationImpl;
}());
LocationImpl = __decorate([
    core_1.Injectable(),
    __param(0, core_1.Inject(document_1.RequestUri)),
    __metadata("design:paramtypes", [String, document_1.DocumentContainer])
], LocationImpl);
exports.LocationImpl = LocationImpl;
//# sourceMappingURL=location.js.map