Object.defineProperty(exports, "__esModule", { value: true });
var chalk = require("chalk");
var exception_1 = require("../../exception");
var assertionFailure = function (identifier) {
    console.error(chalk.red("This application is executing in a context where '" + identifier + "' is defined"));
    console.error(chalk.red("This is completely unexpected and unsupported"));
    console.error(chalk.red('Please ensure that you have not imported a conflicting DOM library like jsdom!'));
    throw new exception_1.PlatformException("Running in a browserless environment but '" + identifier + "' is non-null!");
};
if (typeof window !== 'undefined') {
    assertionFailure('window');
}
if (typeof document !== 'undefined') {
    assertionFailure('document');
}
if (typeof Zone === 'undefined') {
    throw new exception_1.PlatformException("Zone is undefined (import zone.js into this process)");
}
//# sourceMappingURL=assertions.js.map