Object.defineProperty(exports, "__esModule", { value: true });
var domino = require('domino-modernized');
var animation_1 = require("./animation");
var base64_1 = require("./base64");
var control_1 = require("./control");
var events_1 = require("./events");
var http_1 = require("./http");
var interaction_1 = require("./interaction");
var mutation_observer_1 = require("./mutation-observer");
var navigator_1 = require("./navigator");
var position_1 = require("./position");
var selection_1 = require("./selection");
var storage_1 = require("./storage");
var style_1 = require("./style");
var types_1 = require("./types");
Object.assign(global, { __domino_frozen__: false }); // allow overwrite
var conditionalOverwrite = function (target, fills) {
    for (var _i = 0, fills_1 = fills; _i < fills_1.length; _i++) {
        var _a = fills_1[_i], overwrite = _a[0], properties = _a[1];
        for (var k in properties) {
            if (overwrite || typeof target[k] === 'undefined') {
                Object.defineProperty(target, k, {
                    configurable: true,
                    enumerable: false,
                    value: properties[k],
                    writable: true,
                });
            }
        }
    }
};
exports.upgradeWindow = function (target, window) {
    var DOM = domino.impl;
    conditionalOverwrite(target, [
        [true, DOM],
        [true, types_1.bindTypes],
        animation_1.bindAnimation(window),
        base64_1.bindBase64(window),
        control_1.bindControl(window),
        events_1.bindEvents(window),
        http_1.bindHttp(window),
        interaction_1.bindInteractions(window),
        mutation_observer_1.bindMutation(window),
        navigator_1.bindNavigator(window),
        position_1.bindPosition(window),
        selection_1.bindSelection(window),
        storage_1.bindStorage(window),
        style_1.bindStyle(window),
    ]);
    if (target.document) {
        conditionalOverwrite(target.document, [
            selection_1.bindSelection(function () { return window().document; })
        ]);
    }
};
exports.createModernWindow = function (template, uri) {
    var newWindow = domino.createWindow(template, uri);
    exports.upgradeWindow(newWindow, function () { return newWindow; });
    return newWindow;
};
//# sourceMappingURL=create.js.map