Object.defineProperty(exports, "__esModule", { value: true });
var exception_1 = require("../../exception");
var container_1 = require("../../platform/document/container");
var flatten_1 = require("../../transformation/flatten");
var inject_1 = require("./inject");
var prebootImpl = require("preboot");
exports.injectPreboot = function (moduleRef, vop) {
    var preboot = vop.scope.preboot;
    if (!preboot) {
        return;
    }
    var elements = function (array) { return array != null && array.length > 0; };
    var noSeparateRoots = !elements(preboot.serverClientRoot) ||
        preboot.serverClientRoot.some(function (r) { return !elements(r.clientSelector) || !elements(r.serverSelector); });
    var noSingleRoot = preboot.appRoot == null || preboot.appRoot.length === 0;
    var autodetect = noSeparateRoots === true && noSingleRoot === true;
    if (autodetect) {
        var _bootstrapComponents = moduleRef._bootstrapComponents;
        if (_bootstrapComponents == null || _bootstrapComponents.length === 0) {
            throw new exception_1.ConfigurationException("Cannot auto-detect preboot root because no components are defined in module 'bootstrap' properties");
        }
        var selectors = function (c) {
            var component = Reflect.getOwnMetadata('annotations', c).find(function (c) { return c.toString() === '@Component'; });
            if (component == null ||
                component.selector == null ||
                component.selector.length === 0) {
                return null;
            }
            return component.selector.split(/[\s,]/g).filter(function (v) { return v; });
        };
        preboot.appRoot = flatten_1.flatten(_bootstrapComponents.map(selectors)).filter(function (v) { return v; });
    }
    var container = moduleRef.injector.get(container_1.DocumentContainer);
    inject_1.injectIntoDocument(container.document, prebootImpl.getInlineCode(preboot));
};
//# sourceMappingURL=preboot.js.map