Object.defineProperty(exports, "__esModule", { value: true });
var application_1 = require("../../application");
var document_1 = require("./document");
exports.loadApplicationFixtureFromModule = function (moduleType, fn) {
    var builder = application_1.applicationBuilderFromModule(moduleType);
    builder.templateDocument(document_1.templateDocument);
    if (fn) {
        fn(builder);
    }
    return builder.build();
};
exports.renderModuleFixture = function (moduleType) {
    var application = exports.loadApplicationFixtureFromModule(moduleType);
    var observable = application.prerender();
    var dispose = function () { return application.dispose(); };
    observable.subscribe(dispose, dispose);
    return observable;
};
//# sourceMappingURL=module.js.map