Object.defineProperty(exports, "__esModule", { value: true });
var filesystem_1 = require("../../filesystem");
var exception_1 = require("../../exception");
var tsconfigFromPath = function (path) {
    var tsconfig = path.findInAncestor('tsconfig.json');
    if (tsconfig == null) {
        throw new exception_1.FilesystemException("Cannot locate tsconfig.json from " + path.toString());
    }
    return tsconfig;
};
exports.getApplicationRoot = function () {
    var path = filesystem_1.pathFromString(__dirname);
    var tsconfig = tsconfigFromPath(path);
    return tsconfig.parent();
};
exports.getApplicationProject = function (moduleId, moduleSymbol, workingPath) {
    var path = filesystem_1.pathFromString(__dirname);
    var tsconfig = tsconfigFromPath(path);
    return {
        basePath: tsconfig.parent(),
        tsconfig: tsconfig,
        workingPath: workingPath || filesystem_1.pathFromRandomId(),
        applicationModule: {
            source: moduleId,
            symbol: moduleSymbol,
        }
    };
};
//# sourceMappingURL=project.js.map