var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var type_to_function_1 = require("../type-to-function");
describe('typeToInjectorFunction', function () {
    it('instantiates a class decorated with @Injectable()', function () {
        var InjectableClass = (function () {
            function InjectableClass() {
            }
            InjectableClass.prototype.foo = function () {
                return 1;
            };
            return InjectableClass;
        }());
        InjectableClass = __decorate([
            core_1.Injectable()
        ], InjectableClass);
        var fn = type_to_function_1.typeToInjectorFunction(InjectableClass, function (c) { return c.foo(); });
        expect(typeof fn).toBe('function');
        expect(fn.length).toBe(1);
        var executed = fn(null);
        expect(executed).toBe(1);
    });
    it('does not convert functions that are not @Injectable()', function () {
        var fn = type_to_function_1.typeToInjectorFunction(function (injector) { return 1; }, function (c) { throw new Error(); });
        expect(typeof fn).toBe('function');
        expect(fn(null)).toBe(1);
    });
});
//# sourceMappingURL=type-to-function.js.map