Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var decorators_1 = require("../platform/module/metadata/decorators");
exports.typeToInjectorFunction = function (classOrFunction, execute) {
    try {
        if (decorators_1.isInjectable(classOrFunction) === false) {
            return classOrFunction;
        }
        else {
            return instantiator(classOrFunction, execute);
        }
    }
    catch (exception) {
        return classOrFunction;
    }
};
var instantiator = function (type, execute) {
    return function (injector) {
        var descendantInjector = core_1.ReflectiveInjector.resolveAndCreate([type], injector);
        var reader = descendantInjector.get(type);
        return execute(reader);
    };
};
//# sourceMappingURL=type-to-function.js.map